<?php

if (!defined('ABSPATH')) exit; // Exit if accessed directly /**

/**
 * Plugin Name: Add-ons WooGlop
 * Plugin URI: https://www.glop.es/
 * Description: Add-ons WooGlop
 * Author: Glop.es
 * Author URI: http://glop.es
 * Text Domain: Glop
 * Domain Path: /languages
 * Version: 1.3.1
 * Domain Path: /languages
 * License: GPL2
 */

// load plugin's text domaim


add_action('plugins_loaded', 'byconsolewooodt_load_text_domain');

function byconsolewooodt_load_text_domain() {

	$byc_lang_path = dirname(plugin_basename(__FILE__)) . '/languages/';

	if (load_plugin_textdomain('byconsole-woo-order-delivery-time', false, $byc_lang_path));

}

include ('inc/admin.php');

global $woocommerce;

// we need cookie so lets have a safe and confirm way


add_action('init', 'byconsolewooodtSetCookie', 1);

function byconsolewooodtSetCookie()
{
    $c = isset( $_COOKIE['byconsolewooodt_delivery_widget_cookie'] ) ? json_decode( stripslashes( $_COOKIE['byconsolewooodt_delivery_widget_cookie'] ) ) : null;
    $is_take_away = (
            isset( $c ) &&
            $c->byconsolewooodt_widget_type_field === 'take_away'
        );

    if ( ! empty( get_byconsolewooodt_chekout_email_pedido_establecimiento() ) && ! $is_take_away ) {
        $_POST['billing_email'] = get_byconsolewooodt_chekout_email_pedido_establecimiento();
    }

    if ( ! empty( get_byconsolewooodt_chekout_nombre_pedido_establecimiento() ) && ! $is_take_away ) {
        $_POST['billing_first_name'] = get_byconsolewooodt_chekout_nombre_pedido_establecimiento();
    }

    if ( ! empty( get_byconsolewooodt_chekout_apellidos_pedido_establecimiento() ) && ! $is_take_away ) {
        $_POST['billing_last_name'] = get_byconsolewooodt_chekout_apellidos_pedido_establecimiento();
    }

	if ( ! is_wooglop_addons_delivery_enabled() ) {
	    unset( $_COOKIE['byconsolewooodt_delivery_widget_cookie'] );
		setcookie( 'byconsolewooodt_delivery_widget_cookie', null, -1, '/' );
		return;
    }

	// set default values if empty to avoid undefined index issue using cookies
	$byconsolewooodt_widget_tipo_entrega = get_option('byconsolewooodt_widget_tipo_entrega');
	$solo_un_tipo_entrega = is_array( $byconsolewooodt_widget_tipo_entrega ) &&
                            1 == count( $byconsolewooodt_widget_tipo_entrega );

	if (empty($_COOKIE['byconsolewooodt_delivery_widget_cookie']) || $solo_un_tipo_entrega)
	{

		$byconsolewooodt_widget_tipo_entrega = get_option('byconsolewooodt_widget_tipo_entrega');
        if ( is_array( $byconsolewooodt_widget_tipo_entrega ) ) {
	        $byconsolewooodt_widget_tipo_entrega = ( current( $byconsolewooodt_widget_tipo_entrega ) );
        }
		$entrega_por_defecto = $byconsolewooodt_widget_tipo_entrega;

		if ( $entrega_por_defecto == 'solo_local' ) $entrega_por_defecto = 'take_away';
		if ( $entrega_por_defecto == 'solo_envio' ) $entrega_por_defecto = 'levering';

		$byconsolewooodt_delivery_widget = array(

			'byconsolewooodt_widget_date_field' => '',

			'byconsolewooodt_widget_time_field' => '',

			'byconsolewooodt_widget_type_field' => $entrega_por_defecto

		);

		$json_byconsolewooodt_delivery_widget = json_encode($byconsolewooodt_delivery_widget);

		setcookie('byconsolewooodt_delivery_widget_cookie', $json_byconsolewooodt_delivery_widget, time() + 60 * 60 * 24 * 1, '/');

		if (empty($_COOKIE['byconsolewooodt_delivery_widget_cookie']))
		{

			$_COOKIE['byconsolewooodt_delivery_widget_cookie'] = json_encode($byconsolewooodt_delivery_widget);

		}

	}

	// DANIEL RUIZ
    if( is_wooglop_addons_cerrar_tienda() ) {
	    add_filter( 'woocommerce_is_purchasable', '__return_false');
    }

}

// front-end widget


class byconsolewooodt_widget extends WP_Widget
{

	function __construct()
	{

		parent::__construct(

		// Base ID of our widget


			'byconsolewooodt_widget',

			// Widget name will appear in UI


			__('Order delivery time widget', 'byconsole-woo-order-delivery-time') ,

			// Widget description


			array(
				'description' => __('Widget para que los usuarios elijan hora y fecha de entrega', 'byconsole-woo-order-delivery-time') ,
			)
		);

	}

	// Creating widget front-end


	// This is where the action happens


	public function widget($args, $instance)
	{

		if ( ! is_wooglop_addons_delivery_enabled() ) return;

		echo $args['before_widget'];

		if (!empty($instance['byconsolewooodt_widget_title']))
		{

			echo $args['before_title'] . apply_filters('widget_title', $instance['byconsolewooodt_widget_title']) . $args['after_title'];

		}

		//echo __( esc_attr( 'Enter your delivery date and time' ), 'byconsole-woo-order-delivery-time' );


		echo $args['after_widget'];

		$stripped_out_byconsolewooodt_delivery_widget_cookie = stripslashes($_COOKIE['byconsolewooodt_delivery_widget_cookie']);

		$byconsolewooodt_delivery_widget_cookie_array = json_decode($stripped_out_byconsolewooodt_delivery_widget_cookie, true);

		//var_dump( $byconsolewooodt_delivery_widget_cookie_array);


		$byconsolewooodt_delivery_date = !empty($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_date_field']) ? $byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_date_field'] : false;

		$byconsolewooodt_delivery_time = !empty($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_time_field']) ? $byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_time_field'] : false;

		$byconsolewooodt_delivery_type = !empty($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field']) ? $byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] : false;

		$byconsolewooodt_widget_tipo_entrega = !empty($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_tipo_entrega']) ? $byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_tipo_entrega'] : array( 'solo_local' ) ;

		//$byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field']


		$byconsolewooodt_takeaway_lable = get_option('byconsolewooodt_takeaway_lable');

		$byconsolewooodt_delivery_lable = get_option('byconsolewooodt_delivery_lable');

		$byconsolewooodt_establecimiento_lable = get_option('byconsolewooodt_establecimiento_lable');

		//for translations


		$byconsolewooodt_takeaway_lable = get_option('byconsolewooodt_takeaway_lable');

		$byconsolewooodt_delivery_lable = get_option('byconsolewooodt_delivery_lable');

		$byconsolewooodt_date_field_text = get_option('byconsolewooodt_date_field_text');

		$byconsolewooodt_time_field_text = get_option('byconsolewooodt_time_field_text');

		// get cookie as array


		$stripped_out_byconsolewooodt_delivery_widget_cookie = stripslashes($_COOKIE['byconsolewooodt_delivery_widget_cookie']);

		$byconsolewooodt_delivery_widget_cookie_array = json_decode($stripped_out_byconsolewooodt_delivery_widget_cookie, true);

		if (!empty($byconsolewooodt_takeaway_lable)) { } else {
			$byconsolewooodt_takeaway_lable = __('Para llevar', 'byconsole-woo-order-delivery-time');
		}

		if (!empty($byconsolewooodt_delivery_lable)) { } else {
		    $byconsolewooodt_delivery_lable = __('Entrega', 'byconsole-woo-order-delivery-time');
		}

		if (!empty($byconsolewooodt_date_field_text ) ) { } else {
			$byconsolewooodt_date_field_text = __('Seleccionar fecha', 'byconsole-woo-order-delivery-time');
		}

		if ( ! empty( $byconsolewooodt_time_field_text ) ) { } else {
			$byconsolewooodt_time_field_text = __('Seleccionar hora', 'byconsole-woo-order-delivery-time');
		}

		$byconsolewooodt_widget_tipo_entrega = get_option('byconsolewooodt_widget_tipo_entrega');
        $solo_un_tipo_entrega = 1 == count( $byconsolewooodt_widget_tipo_entrega );
		?>


        <form action="" method="post" class="byconsolewooodt_delivery_type_for_widget">


            <div class="byconsolewooodt_delivery_type_for_widget">

                <?php if ( in_array( 'solo_local', $byconsolewooodt_widget_tipo_entrega ) ) : ?>

                    <input type="radio" name="byconsolewooodt_widget_type_field"
                           value="take_away" <?php if ($solo_un_tipo_entrega || $byconsolewooodt_delivery_type == 'take_away')
					{
						echo ' checked="checked"';
					} ?>/>
                    <label for="byconsolewooodt_delivery_type_take_away"
                           class="radio "><?php echo $byconsolewooodt_takeaway_lable; ?></label>
                <?php endif; ?>

				<?php if ( in_array( 'solo_envio', $byconsolewooodt_widget_tipo_entrega ) ) : ?>
                    <input type="radio" name="byconsolewooodt_widget_type_field"
                           value="levering"<?php if ($solo_un_tipo_entrega || $byconsolewooodt_delivery_type == 'levering')
					{
						echo ' checked="checked"';
					} ?> />
                    <label for="byconsolewooodt_delivery_type_levering"
                           class="radio "><?php echo $byconsolewooodt_delivery_lable; ?></label>

                <?php endif; ?>

				<?php if ( in_array( 'solo_establecimiento', $byconsolewooodt_widget_tipo_entrega ) ) : ?>
                    <input type="radio" name="byconsolewooodt_widget_type_field"
                           value="solo_establecimiento"<?php if ($solo_un_tipo_entrega || $byconsolewooodt_delivery_type == 'solo_establecimiento')
					{
						echo ' checked="checked"';
					} ?> />

                    <label for="byconsolewooodt_delivery_type_levering"
                           class="radio "><?php echo $byconsolewooodt_establecimiento_lable; ?></label>

				<?php endif; ?>
            </div>


            <br/>


            <input type="text" name="byconsolewooodt_widget_date_field" class="byconsolewooodt_widget_date_field"
                   placeholder="<?php echo $byconsolewooodt_date_field_text; ?>" readonly="readonly"
                   value="<?php echo $byconsolewooodt_delivery_date; ?>"/>


            <input type="text" name="byconsolewooodt_delivery_date_alternate"
                   class="byconsolewooodt_widget_date_field_alternate"
                   id="byconsolewooodt_delivery_date_alternate_widget" readonly="readonly"
                   value="<?php echo $byconsolewooodt_delivery_date_alternate; ?>" style="display:none;"/>


            <input type="text" name="byconsolewooodt_widget_time_field" class="byconsolewooodt_widget_time_field"
                   placeholder="<?php echo $byconsolewooodt_time_field_text; ?>"
                   value="<?php echo $byconsolewooodt_delivery_time; ?>"/>


            <br/>

            <p class="byc_service_time_closed"></p>


			<?php

			if ($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] == 'levering')
			{
				?>


                <p class="min-shipping-time"><img
                            src="<?php echo plugins_url('images/min-shipping-time.png', __FILE__) ?>"
                            alt="Minimum delivery time"/>
                    &nbsp; <?php echo get_option('byconsolewooodt_delivery_times'); ?></p>


				<?php
			} ?>


            <input type="submit" name="byconsolewooodt_widget_submit" value="Save"/>


        </form>


		<?php

		echo $args['after_widget'];

		//pre-order settings



		?>


        <script>


            jQuery(document).ready(function () {


                delivery_opening_time = "<?php echo get_option('byconsolewooodt_delivery_hours_from'); ?>";


                pickup_opening_time = "<?php echo get_option('byconsolewooodt_opening_hours_from'); ?>";


                delivery_ending_time = "<?php echo get_option('byconsolewooodt_delivery_hours_to'); ?>";


                pickup_ending_time = "<?php echo get_option('byconsolewooodt_opening_hours_to'); ?>";



				<?php

				if (get_option('byconsolewooodt_preorder_days') == '')
				{ // if no pre-order date is not set in settings page



				?>



                jQuery(".byconsolewooodt_widget_date_field").datepicker({


                    minDate: 0,


                    showAnim: "slideDown",


                    altField: ".byconsolewooodt_widget_date_field_alternate",


                    altFormat: "dd/m/yy",


                    onSelect: function () {
                        jQuery(".byconsolewooodt_widget_time_field").timepicker("remove");
                        jQuery(".byconsolewooodt_widget_time_field").val('');
                        ByconsolewooodtDeliveryWidgetTimePopulate(".byconsolewooodt_widget_date_field", ".byconsolewooodt_widget_time_field");
                    } // reset timepicker on date selection to get new time value depending date selected here AND THEN call call time population function


                });



				<?php

				}
				else
				{ //if no pre-order date is set in settings page do the date selection restriction



				?>



                jQuery(".byconsolewooodt_widget_date_field").datepicker({


                    minDate: 0,


                    maxDate: "<?php echo get_option('byconsolewooodt_preorder_days'); ?>+D",


                    showOtherMonths: true,


                    selectOtherMonths: true,


                    showAnim: "slideDown",


                    altField: ".byconsolewooodt_widget_date_field_alternate",


                    altFormat: "dd/m/yy",


                    onSelect: function () {
                        jQuery(".byconsolewooodt_widget_time_field").timepicker("remove");
                        jQuery(".byconsolewooodt_widget_time_field").val('');
                        ByconsolewooodtDeliveryWidgetTimePopulate(".byconsolewooodt_widget_date_field", ".byconsolewooodt_widget_time_field");
                    } // reset timepicker on date selection to get new time value depending date selected here AND THEN call call time population function


                });



				<?php
				}

				//synchornize both the delivery type radio button in widget and in checkout field in simple way


				if ($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] == 'levering')
				{
				    ?>
                jQuery("#byconsolewooodt_delivery_type_levering").prop("checked", true);
				    <?php
				}

				if ($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] == 'take_away')
				{

				?>



                jQuery("#byconsolewooodt_delivery_type_take_away").prop("checked", true);



				<?php
				} ?>



                jQuery("input#byconsolewooodt_delivery_date").val("<?php echo $byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_date_field']; ?>");


                jQuery("input#byconsolewooodt_delivery_time").val("<?php echo $byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_time_field']; ?>");


            })


        </script>


		<?php

	}

	// Widget Backend


	public function form($instance)
	{

		if (isset($instance['byconsolewooodt_widget_title']))
		{

			$title = $instance['byconsolewooodt_widget_title'];

		}
		else
		{

			$title = __('Nuevo titulo', 'byconsole-woo-order-delivery-time');

		}

		// Widget admin form



		?>


        <p>


            <label for="<?php echo $this->get_field_id('byconsolewooodt_widget_title'); ?>"><?php __('Titulo:', 'byconsole-woo-order-delivery-time'); ?></label>


            <input class="widefat" id="<?php echo $this->get_field_id('byconsolewooodt_widget_title'); ?>"
                   name="<?php echo $this->get_field_name('byconsolewooodt_widget_title'); ?>" type="text"
                   value="<?php echo esc_attr($title); ?>"/>


        </p>


		<?php

	}

	// Updating widget replacing old instances with new


	public function update($new_instance, $old_instance)
	{
		return 0; /*Modificado para no actualizar*/
	}

	/*****************************************************/

} // Class byconsolewooodt_widget ends here


// Register and load the widget


function byconsolewooodt_load_widget()
{

	register_widget('byconsolewooodt_widget');

}

add_action('widgets_init', 'byconsolewooodt_load_widget'); //save frontend widget data in cookie, so we need to do it before any output, hence hook it on init


function byconsolewooodt_savefrontend_widget_data()
{

	// save thwe widget data in in cookie


	if (isset($_POST['byconsolewooodt_widget_submit']))
	{

		$byconsolewooodt_widget_tipo_entrega = get_option('byconsolewooodt_widget_tipo_entrega');
		$solo_un_tipo_entrega = 1 == count( $byconsolewooodt_widget_tipo_entrega );

		// levering = solo_local
        // take_away = solo_envio
        // solo_establecimiento =
		if ( $solo_un_tipo_entrega ) {
		    switch ( $byconsolewooodt_widget_tipo_entrega ) {
                case 'solo_local':
					$_POST['byconsolewooodt_widget_type_field'] = 'levering';
					break;
                case 'solo_envio':
                    $_POST['byconsolewooodt_widget_type_field'] = 'away =';
                    break;
				default:
				$_POST['byconsolewooodt_widget_type_field'] = 'solo_establecimiento';
            }
        }

		$byconsolewooodt_delivery_widget_post_array = array(

			'byconsolewooodt_widget_date_field' => $_POST['byconsolewooodt_widget_date_field'],

			'byconsolewooodt_widget_time_field' => $_POST['byconsolewooodt_widget_time_field'],

			'byconsolewooodt_widget_type_field' => $_POST['byconsolewooodt_widget_type_field'],

		);

		//set cookie


		$json_byconsolewooodt_delivery_widget_post_array = json_encode($byconsolewooodt_delivery_widget_post_array);

		setcookie('byconsolewooodt_delivery_widget_cookie', $json_byconsolewooodt_delivery_widget_post_array, time() + 60 * 60 * 24 * 1, '/');

		$_COOKIE['byconsolewooodt_delivery_widget_cookie'] = $json_byconsolewooodt_delivery_widget_post_array; // for immediate access in widget



	}

} // end of byconsolewooodt_savefrontend_widget_data


add_action('init', 'byconsolewooodt_savefrontend_widget_data'); // Add the field to the checkout


//add_action( 'woocommerce_after_order_notes', 'byconsolewooodt_checkout_field' );


add_action('woocommerce_checkout_before_customer_details', 'byconsolewooodt_checkout_field');

function byconsolewooodt_checkout_field($checkout)
{

	global $woocommerce; // get cookie as array
	/********************************/

	$bycwooodt_has_virtual_products = false;

	// Default virtual products number
	$bycwooodt_virtual_products = 0;

	// Get all products in cart
	$bycwooodt_products = $woocommerce
		->cart
		->get_cart();

	// Loop through cart products
	foreach ($bycwooodt_products as $bycwooodt_product)
	{

		// Get product ID and '_virtual' post meta
		$bycwooodt_product_id = $bycwooodt_product['product_id'];
		$bycwooodt_is_virtual = get_post_meta($bycwooodt_product_id, '_virtual', true);

		// Update $has_virtual_product if product is virtual
		if ($bycwooodt_is_virtual == 'yes') $bycwooodt_virtual_products += 1;
	}

	if (count($bycwooodt_products) == $bycwooodt_virtual_products)
	{
		$bycwooodt_both_product_count_val = 'same';
	}
	else
	{
		$bycwooodt_both_product_count_val = 'not_same';
	}

	//echo $bycwooodt_both_product_count_val;
	//$has_virtual_products = true;
	/********************************/

	if ($bycwooodt_both_product_count_val == 'not_same') {

		$byconsolewooodt_takeaway_lable = get_option('byconsolewooodt_takeaway_lable');

		$byconsolewooodt_delivery_lable = get_option('byconsolewooodt_delivery_lable');

		$byconsolewooodt_establecimiento_lable = get_option('byconsolewooodt_establecimiento_lable');

		$byconsolewooodt_date_field_text = get_option('byconsolewooodt_date_field_text');

		$byconsolewooodt_time_field_text = get_option('byconsolewooodt_time_field_text');

		// get cookie as array


		$stripped_out_byconsolewooodt_delivery_widget_cookie = stripslashes($_COOKIE['byconsolewooodt_delivery_widget_cookie']);

		$byconsolewooodt_delivery_widget_cookie_array = json_decode($stripped_out_byconsolewooodt_delivery_widget_cookie, true);

		if (!empty($byconsolewooodt_takeaway_lable)) {
			//$byconsolewooodt_takeaway_lable =  get_option('byconsolewooodt_takeaway_lable');
		} else {
			$byconsolewooodt_takeaway_lable = __('Para llevar', 'byconsole-woo-order-delivery-time');
		}

		if (!empty($byconsolewooodt_delivery_lable)) {
			//$byconsolewooodt_delivery_lable =  get_option('byconsolewooodt_delivery_lable');
		} else {
			$byconsolewooodt_delivery_lable = __('Recoger', 'byconsole-woo-order-delivery-time');
		}
		if (!empty($byconsolewooodt_date_field_text)) {
			//$byconsolewooodt_date_field_text =  get_option('byconsolewooodt_date_field_text');

		} else {
			$byconsolewooodt_date_field_text = __('Seleccionar fecha', 'byconsole-woo-order-delivery-time');
		}
		if (!empty($byconsolewooodt_time_field_text)) {
			//$byconsolewooodt_time_field_text =  get_option('byconsolewooodt_time_field_text');

		} else {
			$byconsolewooodt_time_field_text = __('Seleccionar hora', 'byconsole-woo-order-delivery-time');
		}

		$get_option_byconsolewooodt_chekout_page_order_type_label = get_option('byconsolewooodt_chekout_page_order_type_label');

		if (!empty($get_option_byconsolewooodt_chekout_page_order_type_label)) {
		} else {
			$get_option_byconsolewooodt_chekout_page_order_type_label = __('Seleccione el tipo de orden', 'byconsole-woo-order-delivery-time');
		}

		$get_option_byconsolewooodt_chekout_page_date_label = get_option('byconsolewooodt_chekout_page_date_label');

		if (!empty($get_option_byconsolewooodt_chekout_page_date_label)) {
			//$get_option_byconsolewooodt_chekout_page_date_lebel=get_option('byconsolewooodt_chekout_page_date_label');

		} else {
			$get_option_byconsolewooodt_chekout_page_date_label = __('Seleccionar fecha', 'byconsole-woo-order-delivery-time');
		}

		$get_option_byconsolewooodt_chekout_page_time_label = get_option('byconsolewooodt_chekout_page_time_label');

		if (!empty($get_option_byconsolewooodt_chekout_page_time_label)) {
		} else {
			$get_option_byconsolewooodt_chekout_page_time_label = __('Seleccionar hora', 'byconsole-woo-order-delivery-time');
		}


		if ( is_wooglop_addons_delivery_enabled() ) {

            echo '<div id="byconsolewooodt_checkout_field"><h2>' . get_option('byconsolewooodt_chekout_page_section_heading') . '</h2>';

			$accent_color = get_theme_mod( 'accent_color', '#7DA81C' );
			if ( isset( $accent_color ) ) {
                ?><style type="text/css">
                    .byconsolewooodt_delivery_type input:checked + label[for="byconsolewooodt_delivery_type_take_away"],
                    .byconsolewooodt_delivery_type input:checked + label[for="byconsolewooodt_delivery_type_levering"],
                    .byconsolewooodt_delivery_type input:checked + label[for="byconsolewooodt_delivery_type_solo_establecimiento"] {
                        border-color: <?php echo $accent_color; ?>;
                    }
                </style><?php
            }

            $byconsolewooodt_widget_tipo_entrega = get_option('byconsolewooodt_widget_tipo_entrega');

            $opciones_de_entrega = array();
            if ( in_array( 'solo_local', $byconsolewooodt_widget_tipo_entrega ) ) {
                $opciones_de_entrega['take_away'] =  $byconsolewooodt_takeaway_lable;
    //			$byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] = 'take_away';
            }

            if ( in_array( 'solo_envio', $byconsolewooodt_widget_tipo_entrega ) ) {
                $opciones_de_entrega['levering'] = $byconsolewooodt_delivery_lable;
    //			$byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] = 'levering';
            }

            $type_date = 'text';
            if ( in_array( 'solo_establecimiento', $byconsolewooodt_widget_tipo_entrega ) ) {
                $opciones_de_entrega['solo_establecimiento'] =  $byconsolewooodt_establecimiento_lable;
    //			$byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] = 'solo_establecimiento';
            }


            if ( in_array( $byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'], array( 'solo_establecimiento' ) ) ) {
                $type_date = 'hidden';
            }

            $clases = [ 'byconsolewooodt_delivery_type' ];
            if ( 1 == count( $opciones_de_entrega ) ) {
                $clases[] = ' hidden2';
            }



            woocommerce_form_field('byconsolewooodt_delivery_type', array(
                'type' => 'radio',
                'required' => 'true',
                'class' => $clases,
                'label' => $get_option_byconsolewooodt_chekout_page_order_type_label,
                'placeholder' => __('Select delivery type', 'byconsole-woo-order-delivery-time'),
                'default' => $byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'],
                'checked' => 'checked',
                'options' => $opciones_de_entrega
            ));

            if ($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] == 'levering')
            {
                ?><p class="min-shipping-time"> <?php echo get_option('byconsolewooodt_delivery_times'); ?></p><?php
            }


            $byconsolewooodt_hours_format_optional = get_option('byconsolewooodt_hours_format_optional');
            if ( 'Oculto' != $byconsolewooodt_hours_format_optional ) {
                woocommerce_form_field('byconsolewooodt_delivery_date', array(
                    'type' => $type_date,
                    'required' => 'true',
                    'class' => array(
                        'byconsolewooodt_delivery_date'
                    ) ,
                    'label' => $get_option_byconsolewooodt_chekout_page_date_label,
                    'placeholder' => __($byconsolewooodt_date_field_text, 'byconsole-woo-order-delivery-time') ,
                    'default' => $byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_date_field']
                ));

                woocommerce_form_field('byconsolewooodt_delivery_date_alternate', array(
                    'type' => 'text',
                    'class' => array(
                        'byconsolewooodt_delivery_date_alternate'
                    ) ,
                    'label' => '',
                    'placeholder' => '',
                    'default' => '',
                ));

                woocommerce_form_field('byconsolewooodt_delivery_time', array(
                    'type' => $type_date,
                    'required' => 'true',
                    'class' => array(
                        'byconsolewooodt_delivery_time'
                    ) ,
                    'label' => $get_option_byconsolewooodt_chekout_page_time_label,
                    'placeholder' => __($byconsolewooodt_time_field_text, 'byconsole-woo-order-delivery-time') ,
                    'default' => $byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_time_field']
                ));

                echo '<p class="byc_service_time_closed"></p></div>';

            }

			$json_alias_opcional = get_option( 'byconsolewooodt_chekout_page_alias_texto_opcional' );
            if ( in_array( $byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'], array( 'solo_establecimiento' ) ) && $json_alias_opcional != 'Oculto' ) {
                echo '<div class="col2-set" id="customer_details"><div class="col-1">';
                $json_alias             = get_option( 'byconsolewooodt_chekout_page_alias_texto' );
                $json_alias_placeholder = get_option( 'byconsolewooodt_chekout_page_alias_placeholder' );


                $res = null;
	            if ( isset( $_COOKIE['mesa_selected'] ) ) {
		            $res =  $_COOKIE['mesa_selected'];
	            }
	            if ( isset( $_GET['mesa'] ) ) {
		            $res = $_GET['mesa'];
	            }


                woocommerce_form_field('byconsolewooodt_chekout_page_alias_texto', array(
                    'type' => 'text',
                    'class' => array( ) ,
                    'label' => $json_alias,
                    'placeholder' => $json_alias_placeholder,
                    'default' => $res,
                    'maxlength' => 60,
                    'required' => $json_alias_opcional == 'Obligatorio'
                ));
                echo '</div></div>';

            }

        }




	}
}

// Validate the custom field.


add_action('woocommerce_checkout_process', 'byconsolewooodt_checkout_field_process');

function byconsolewooodt_checkout_field_process() {

    if ( ! is_wooglop_addons_delivery_enabled() ) return;

	global $woocommerce;
	$bycwooodt_has_virtual_products = false;

	// Default virtual products number.
	$bycwooodt_virtual_products = 0;

	// Get all products in cart.
	$bycwooodt_products = $woocommerce
		->cart
		->get_cart();

	// Loop through cart products.
	foreach ( $bycwooodt_products as $bycwooodt_product ) {
		// Get product ID and '_virtual' post meta.
		$bycwooodt_product_id = $bycwooodt_product['product_id'];
		$bycwooodt_is_virtual = get_post_meta( $bycwooodt_product_id, '_virtual', true );

		// Update $has_virtual_product if product is virtual.
		if ($bycwooodt_is_virtual == 'yes') $bycwooodt_virtual_products += 1;
	}

	if ( count( $bycwooodt_products ) == $bycwooodt_virtual_products ) {
		$bycwooodt_both_product_count_val = 'same';
	} else {
		$bycwooodt_both_product_count_val = 'not_same';
	}

	//echo $bycwooodt_both_product_count_val;
	//$has_virtual_products = true;
	/********************************/

    $stripped_out_byconsolewooodt_delivery_widget_cookie = stripslashes($_COOKIE['byconsolewooodt_delivery_widget_cookie']);
	$byconsolewooodt_delivery_widget_cookie_array = json_decode($stripped_out_byconsolewooodt_delivery_widget_cookie, true);
	$byconsolewooodt_delivery_type = !empty($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field']) ? $byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] : false;

	if ($bycwooodt_both_product_count_val == 'not_same' && ! in_array( $byconsolewooodt_delivery_type, array( 'solo_establecimiento' ) ) ) {

		$byconsolewooodt_hours_format_optional = get_option('byconsolewooodt_hours_format_optional');
		if ( 'Obligatorio' == $byconsolewooodt_hours_format_optional ) {
			if ( ! $_POST['byconsolewooodt_delivery_date']) {
//				wc_add_notice(__('<b>La fecha de recogida / entrega </b> es un campo obligatorio.', 'byconsole-woo-order-delivery-time'), 'error');
				wc_add_notice( sprintf( __( '%s is a required field.', 'woocommerce' ), 'Fecha de recogida' ), 'error' );
			}

			if ( ! $_POST['byconsolewooodt_delivery_time'] ) {
				wc_add_notice( sprintf( __( '%s is a required field.', 'woocommerce' ), 'La fecha de recogida / entrega' ), 'error' );
			}
		}
	}


	$json_alias_opcional = get_option( 'byconsolewooodt_chekout_page_alias_texto_opcional' );
	if (
        in_array(
            $byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'],
            array( 'solo_establecimiento' )
        ) && $json_alias_opcional == 'Obligatorio' ) {
		if ( empty( $_POST['byconsolewooodt_chekout_page_alias_texto'] ) ) {
			$json_alias = get_option( 'byconsolewooodt_chekout_page_alias_texto' );
			wc_add_notice( sprintf( __( '%s is a required field.', 'woocommerce' ), $json_alias ), 'error' );

		}
	}

    // DANIEL RUIZ y Ximo el 14 de diciembre.
    if ( 'on' === get_option( 'byconsolewooodt_hay_notas_label' ) ) {
        if ( isset( $_POST['order_comments'] ) && 200 < strlen( $_POST['order_comments'] ) ) {
            wc_add_notice( __( 'Los comentarios de la nota no pueden exceder los 200 caracteres.', 'byconsole-woo-order-delivery-time' ), 'error' );
        }
    }

}

//Save the order meta with field value
add_action('woocommerce_checkout_update_order_meta', 'byconsolewooodt_checkout_field_update_order_meta');

function byconsolewooodt_checkout_field_update_order_meta($order_id)
{

	global $woocommerce; // get cookie as array
	/********************************/

	$bycwooodt_has_virtual_products = false;

	// Default virtual products number
	$bycwooodt_virtual_products = 0;

	// Get all products in cart
	$bycwooodt_products = $woocommerce
		->cart
		->get_cart();

	// Loop through cart products
	foreach ($bycwooodt_products as $bycwooodt_product)
	{

		// Get product ID and '_virtual' post meta
		$bycwooodt_product_id = $bycwooodt_product['product_id'];
		$bycwooodt_is_virtual = get_post_meta($bycwooodt_product_id, '_virtual', true);

		// Update $has_virtual_product if product is virtual
		if ($bycwooodt_is_virtual == 'yes') $bycwooodt_virtual_products += 1;
	}

	if (count($bycwooodt_products) == $bycwooodt_virtual_products)
	{
		$bycwooodt_both_product_count_val = 'same';
	}
	else
	{
		$bycwooodt_both_product_count_val = 'not_same';
	}

	//echo $bycwooodt_both_product_count_val;
	//$has_virtual_products = true;
	/********************************/

	if (!empty($_POST['byconsolewooodt_delivery_date'])) {
		update_post_meta($order_id, 'byconsolewooodt_delivery_date', sanitize_text_field($_POST['byconsolewooodt_delivery_date']));
	}

	if (!empty($_POST['byconsolewooodt_delivery_time'])) {
		update_post_meta($order_id, 'byconsolewooodt_delivery_time', sanitize_text_field($_POST['byconsolewooodt_delivery_time']));
	}

	if (!empty($_POST['byconsolewooodt_delivery_type'])) {
		update_post_meta($order_id, 'byconsolewooodt_delivery_type', $_POST['byconsolewooodt_delivery_type']);
	}

	if (!empty($_POST['byconsolewooodt_chekout_page_alias_texto'])) {
		update_post_meta($order_id, 'byconsolewooodt_chekout_page_alias_texto', $_POST['byconsolewooodt_chekout_page_alias_texto']);
	}

}

//Display field value on the order edit page


add_action('woocommerce_admin_order_data_after_shipping_address', 'byconsolewooodt_checkout_field_display_admin_order_meta', 10, 1);

function byconsolewooodt_checkout_field_display_admin_order_meta($order)
{

	$order_id = version_compare(WC_VERSION, '3.0.0', '<') ? $order->id : $order->get_id();

	$byconsolewooodt_takeaway_lable = get_option('byconsolewooodt_takeaway_lable');

	$byconsolewooodt_delivery_lable = get_option('byconsolewooodt_delivery_lable');

	if (get_post_meta($order_id, 'byconsolewooodt_delivery_type', true) == 'take_away')
	{

		if (!empty($byconsolewooodt_takeaway_lable))
		{

			$order_delivery_type = $byconsolewooodt_takeaway_lable;

		}
		else
		{

			$order_delivery_type = __('Para llevar', 'byconsole-woo-order-delivery-time');

		}

	}

	if (get_post_meta($order_id, 'byconsolewooodt_delivery_type', true) == 'levering')
	{

		if (!empty($byconsolewooodt_delivery_lable))
		{

			$order_delivery_type = $byconsolewooodt_delivery_lable;

		}
		else
		{

			$order_delivery_type = __('Recoger', 'byconsole-woo-order-delivery-time');

		}

	}

	if (!empty(get_post_meta($order_id, 'byconsolewooodt_delivery_time', true)) && !empty(get_post_meta($order_id, 'byconsolewooodt_delivery_date', true)))
	{

		echo '<p><strong>' . __('Fecha de entrega/recogida', 'byconsole-woo-order-delivery-time') . ':</strong> ' . get_post_meta($order_id, 'byconsolewooodt_delivery_date', true) . '</p>';

		echo '<p><strong>' . __('Hora de entrega/recogida', 'byconsole-woo-order-delivery-time') . ':</strong> ' . get_post_meta($order_id, 'byconsolewooodt_delivery_time', true) . '</p>';

		echo '<p><strong>' . __('Tipo de entrega/recogida', 'byconsole-woo-order-delivery-time') . ':</strong> ' . $order_delivery_type . '</p>';
	}

}

// Display order meta in order details section


if (get_option('byconsolewooodt_widget_field_position') == 'top')
{ //hook here if it is set to show on top in admin settings page


	//add_action( 'woocommerce_view_order', 'byconsolewooodt_checkout_field_display_user_order_meta', 10, 1 );


	add_action('woocommerce_order_details_after_order_table_items', 'byconsolewooodt_checkout_field_display_user_order_meta', 10, 1);

}

if (get_option('byconsolewooodt_widget_field_position') == 'bottom')
{ //hook here if it is set to show on bottom in admin settings page


	add_action('woocommerce_order_details_after_order_table', 'byconsolewooodt_checkout_field_display_user_order_meta', 10, 1);

}

function byconsolewooodt_checkout_field_display_user_order_meta($order)
{

	$byconsolewooodt_takeaway_lable = get_option('byconsolewooodt_takeaway_lable');

	$byconsolewooodt_delivery_lable = get_option('byconsolewooodt_delivery_lable');

	/*if(get_post_meta( $order->id, 'byconsolewooodt_delivery_type', true )=='take_away'){	$order_delivery_type='Take Away';}



	if(get_post_meta( $order->id, 'byconsolewooodt_delivery_type', true )=='levering'){		$order_delivery_type='Delivery';}*/

	$order_id = version_compare(WC_VERSION, '3.0.0', '<') ? $order->id : $order->get_id();

	if (get_post_meta($order_id, 'byconsolewooodt_delivery_type', true) == 'take_away')
	{

		if (!empty($byconsolewooodt_takeaway_lable))
		{

			$order_delivery_type = $byconsolewooodt_takeaway_lable;

		}
		else
		{

			$order_delivery_type = __('Para llevar', 'byconsole-woo-order-delivery-time');

		}

	}

	if (get_post_meta($order_id, 'byconsolewooodt_delivery_type', true) == 'levering')
	{

		if (!empty($byconsolewooodt_delivery_lable))
		{

			$order_delivery_type = $byconsolewooodt_delivery_lable;

		}
		else
		{

			$order_delivery_type = __('Recoger', 'byconsole-woo-order-delivery-time');

		}

	}

	if (!empty(get_post_meta($order_id, 'byconsolewooodt_delivery_time', true)) && !empty(get_post_meta($order_id, 'byconsolewooodt_delivery_date', true)))
	{

		echo '<p><strong>' . __('Fecha de entrega/recogida', 'byconsole-woo-order-delivery-time') . ':</strong> ' . get_post_meta($order_id, 'byconsolewooodt_delivery_date', true) . '</p>';

		echo '<p><strong>' . __('Hora de entrega/recogida', 'byconsole-woo-order-delivery-time') . ':</strong> ' . get_post_meta($order_id, 'byconsolewooodt_delivery_time', true) . '</p>';

		echo '<p><strong>' . __('Tipo de entrega/recogida', 'byconsole-woo-order-delivery-time') . ':</strong> ' . $order_delivery_type . '</p>';

	}

	if (get_post_meta($order_id, 'byconsolewooodt_delivery_type', true) == 'levering')
	{

		$prepare_shipping_text = str_replace('[byc_delivery_date]', '<b>' . get_post_meta($order_id, 'byconsolewooodt_delivery_date', true) . '</b>', get_option('byconsolewooodt_orders_delivered'));

		echo '<p>' . str_replace('[byc_delivery_time]', '<b>' . get_post_meta($order_id, 'byconsolewooodt_delivery_time', true) . '</b>', $prepare_shipping_text) . '</p>';

	}

	if (get_post_meta($order_id, 'byconsolewooodt_delivery_type', true) == 'take_away')
	{

		$prepare_shipping_text = str_replace('[byc_pickup_date]', '<b>' . get_post_meta($order_id, 'byconsolewooodt_delivery_date', true) . '</b>', get_option('byconsolewooodt_orders_pick_up'));

		echo '<p>' . str_replace('[byc_pickup_time]', '<b>' . get_post_meta($order_id, 'byconsolewooodt_delivery_time', true) . '</b>', $prepare_shipping_text) . '</p>';

	}

}

//include the custom order meta to woocommerce mail


add_action("woocommerce_email_after_order_table", "byconsolewooodt_woocommerce_email_after_order_table", 10, 1);

function byconsolewooodt_woocommerce_email_after_order_table($order)
{

	$byconsolewooodt_takeaway_lable = get_option('byconsolewooodt_takeaway_lable');

	$byconsolewooodt_delivery_lable = get_option('byconsolewooodt_delivery_lable');

	/*	if(get_post_meta( $order->id, 'byconsolewooodt_delivery_type', true )=='take_away'){ $order_delivery_type='Take Away';}



	if(get_post_meta( $order->id, 'byconsolewooodt_delivery_type', true )=='levering'){	$order_delivery_type='Delivery';}*/

	$order_id = version_compare(WC_VERSION, '3.0.0', '<') ? $order->id : $order->get_id();

	if (get_post_meta($order_id, 'byconsolewooodt_delivery_type', true) == 'take_away')
	{

		if (!empty($byconsolewooodt_takeaway_lable))
		{

			$order_delivery_type = $byconsolewooodt_takeaway_lable;

		}
		else
		{

			$order_delivery_type = __('Para llevar', 'byconsole-woo-order-delivery-time');

		}

	}

	if (get_post_meta($order_id, 'byconsolewooodt_delivery_type', true) == 'levering')
	{

		if (!empty($byconsolewooodt_delivery_lable))
		{

			$order_delivery_type = $byconsolewooodt_delivery_lable;

		}
		else
		{

			$order_delivery_type = __('Recoger', 'byconsole-woo-order-delivery-time');

		}

	}

	if (!empty(get_post_meta($order_id, 'byconsolewooodt_delivery_time', true)) && !empty(get_post_meta($order_id, 'byconsolewooodt_delivery_date', true)))
	{

		echo '<p></p><p><strong>' . __('Fecha de entrega/recogida', 'byconsole-woo-order-delivery-time') . ':</strong> ' . get_post_meta($order_id, 'byconsolewooodt_delivery_date', true) . '</p>';

		echo '<p><strong>' . __('Hora de entrega/recogida', 'byconsole-woo-order-delivery-time') . ':</strong> ' . get_post_meta($order_id, 'byconsolewooodt_delivery_time', true) . '</p>';

		echo '<p><strong>' . __('Tipo de entrega/recogida', 'byconsole-woo-order-delivery-time') . ':</strong> ' . $order_delivery_type . '</p>';

	}

}

// add our styles and js


function byconsolewooodt_add_scripts()
{

	wp_enqueue_script('jquery-ui-datepicker');
	if ( ! is_plugin_active ( 'woocommerce-opening-hours/opening-hours.php' ) ) {
	wp_register_script('byconsolewooodt_script_2', plugins_url('js/jquery.timepicker.min.js', __FILE__) , array(
		'jquery'
	) , '1.12', true);
	}


		wp_register_script( 'byconsolewooodt_script_3', plugins_url( 'js/byconsolewooodt.js', __FILE__ ), array(
			'jquery'
		), time(), true );

	wp_enqueue_script('byconsolewooodt_script_2');

	wp_enqueue_script('byconsolewooodt_script_3');

	$email_pedido_esta     = get_byconsolewooodt_chekout_email_pedido_establecimiento();
	$nombre_pedido_esta    = get_byconsolewooodt_chekout_nombre_pedido_establecimiento();
	$apellidos_pedido_esta = get_byconsolewooodt_chekout_apellidos_pedido_establecimiento();
	if( ! empty( $email_pedido_esta ) || ! empty( $nombre_pedido_esta ) || ! empty( $apellidos_pedido_esta ) ) {
		$remove_email_css = "";
		if( ! empty( $email_pedido_esta ) ) {
			$remove_email_css .= "
               .woocommerce-order-overview__email.email, .woocommerce-checkout .woocommerce-customer-details {
                  display: none;
               }";
		}
		if( ! empty( $nombre_pedido_esta ) ) {
			$remove_email_css .= "
               .woocommerce-order-overview__email.email, .woocommerce-checkout .woocommerce-customer-details {
                  display: none;
               }";
		}
		if( ! empty( $apellidos_pedido_esta ) ) {
			$remove_email_css .= "
               .woocommerce-order-overview__email.email, .woocommerce-checkout .woocommerce-customer-details {
                  display: none;
               }";
		}
		wp_register_style( 'wooglop_remove_email', false );
		wp_enqueue_style( 'wooglop_remove_email' );
		wp_add_inline_style( 'wooglop_remove_email', $remove_email_css );
    }

}

add_action('wp_enqueue_scripts', 'byconsolewooodt_add_scripts');

//add styles


function byconsolewooodt_add_styles()
{

	wp_enqueue_style('byconsolewooodt_stylesheet', plugins_url('css/style.css', __FILE__));

	wp_enqueue_style('byconsolewooodt_stylesheet_2', plugins_url('css/jquery-ui.min.css', __FILE__));

	wp_enqueue_style('byconsolewooodt_stylesheet_3', plugins_url('css/jquery-ui.theme.min.css', __FILE__));

	wp_enqueue_style('byconsolewooodt_stylesheet_4', plugins_url('css/jquery-ui.structure.min.css', __FILE__));

	wp_enqueue_style('byconsolewooodt_stylesheet_5', plugins_url('css/jquery.timepicker.css', __FILE__));

}

add_action('wp_enqueue_scripts', 'byconsolewooodt_add_styles');

// refreshing the cart on page load



/** Break html5 cart caching */

add_action('wp_enqueue_scripts', 'cartcache_enqueue_scripts', 100);

function cartcache_enqueue_scripts()

{

	wp_deregister_script('wc-cart-fragments');

	wp_enqueue_script('wc-cart-fragments', plugins_url('js/cart-fragments.js', __FILE__) , array(
		'jquery',
		'jquery-cookie'
	) , '1.12', true);

}

// show only store pickup when take_away is selected


//


add_filter('woocommerce_package_rates', 'byconsolewooodt_shipping_according_widget_input', 10, 2);

//add_filter('woocommerce_package_rates', 'byconsolewooodt_shipping_according_widget_input', 100);


function byconsolewooodt_shipping_according_widget_input($rates, $package)

{

	// get cookie as array


	$stripped_out_byconsolewooodt_delivery_widget_cookie = stripslashes($_COOKIE['byconsolewooodt_delivery_widget_cookie']);

	$byconsolewooodt_delivery_widget_cookie_array = json_decode($stripped_out_byconsolewooodt_delivery_widget_cookie, true);

	global $woocommerce;

	$version = "2.6";

	if (version_compare($woocommerce->version, $version, ">="))
	{

		$new_rates = array();

		/*echo '<hr />';



		print_r($rates);*/

		if ($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] == 'take_away')
		{

			foreach ($rates as $key => $rate)
			{

				if ('local_pickup' === $rate->method_id || 'legacy_local_pickup' === $rate->method_id)
				{

					$new_rates[$key] = $rates[$key];

				}

			}

			/*print_r($new_rates);



			print_r($rates);*/

		}
        elseif ($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] == 'levering')
		{

			foreach ($rates as $key => $rate)
			{
				if ('local_pickup' != $rate->method_id && 'legacy_local_pickup' != $rate->method_id)
				{
					$new_rates[$key] = $rates[$key];
					//unset($rates['local_pickup']);
				}
			}
		}
		else
		{
			//
		}
		return empty($new_rates) ? $rates : $new_rates;
	}
	else
	{

		if ($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] == 'take_away')
		{

			$predefined_shipping = $rates['local_pickup'];
			$rates = array();
			$rates['local_pickup'] = $predefined_shipping;

		}

		if ($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] == 'levering')
		{

			$predefined_shipping = $rates['flat_rate'];

			$rates = array();

			$rates['flat_rate'] = $predefined_shipping;

		}

		return $rates;

	}

}

// check if checkout page


// do the JS to populate date and time field paqrameter


function byconsolewooodt_wp_head()
{
	?>
    <style>
        #byconsolewooodt_delivery_date_alternate_field {
            display: none;
        }
    </style>
	<?php
}

add_action('wp_head', 'byconsolewooodt_wp_head', 1);

function byconsolewooodt_footer_script()
{

	// get cookie as array


	if (!empty($_COOKIE['byconsolewooodt_delivery_widget_cookie']))
	{

		$stripped_out_byconsolewooodt_delivery_widget_cookie = stripslashes($_COOKIE['byconsolewooodt_delivery_widget_cookie']);

		$byconsolewooodt_delivery_widget_cookie_array = json_decode($stripped_out_byconsolewooodt_delivery_widget_cookie, true);

	}

	?>


    <script>


        function ByConsoleWooODTStartTimeByInterval(cur_hour, cur_minute) {


            if (cur_minute > 0 && cur_minute < 15) {


                var start_minute = 15;


            } else if (cur_minute >= 15 && cur_minute < 30) {


                var start_minute = 30;


            } else if (cur_minute >= 30 && cur_minute < 45) {


                var start_minute = 45;


            } else if (cur_minute >= 45 && cur_minute < 59) {


                var start_minute = 59;


            } else {
            }


            if (start_minute == 59) {


                var next_hour = parseInt(cur_hour) + 1;


                var start_time_updated = next_hour + ":" + "00";


            } else {


                var start_time_updated = cur_hour + ":" + start_minute;


            }


            return start_time_updated;


        } // end of ByConsoleWooODTtimeInterval


        function ByconsolewooodtDeliveryWidgetTimePopulate(date_field_identifier, time_field_identifier) {


// lock the time selection based on admin settings for delivery time


//echo 'var curtime_to_compare=new Date().toLocaleTimeString();';


            service_status = "open";


            var current_date = new Date();


            var curtime = new Date().toLocaleTimeString("en-US", {hour12: false, hour: "numeric", minute: "numeric"});


// get local minute


//var cur_minute= new Date().toLocaleTimeString("en-US", { hour12: false, minute: "numeric"});


            var cur_minute = current_date.getMinutes();


// get local hour


//var cur_hour= new Date().toLocaleTimeString("en-US", { hour12: false, hour: "numeric"});


            var cur_hour = current_date.getHours();

            var curtime = cur_hour + ':' + cur_minute;

            ByConsoleWooODTStartTimeByInterval(cur_hour, cur_minute); // check this function in wp-footer


//populate time field based on date selection (call this function onSelect event of datepicker)


            /*var selected_date=jQuery(".byconsolewooodt_widget_date_field").datepicker( "getDate" );*/


            selected_date = jQuery(date_field_identifier).datepicker('option', 'dateFormat', 'dd M yy').val();


//var byc_delivery_date_alternate = jQuery("#byconsolewooodt_delivery_date_alternate").val().split("/");


            var byc_delivery_date_alternate = jQuery(date_field_identifier + "_alternate").val().split("/");


            if (byc_delivery_date_alternate[1] == 1) {


                byc_delivery_date_alternate_month = 'Jan';


            } else if (byc_delivery_date_alternate[1] == 2) {


                byc_delivery_date_alternate_month = 'Feb';


            } else if (byc_delivery_date_alternate[1] == 3) {


                byc_delivery_date_alternate_month = 'Mar';


            } else if (byc_delivery_date_alternate[1] == 4) {


                byc_delivery_date_alternate_month = 'Apr';


            } else if (byc_delivery_date_alternate[1] == 5) {


                byc_delivery_date_alternate_month = 'May';


            } else if (byc_delivery_date_alternate[1] == 6) {


                byc_delivery_date_alternate_month = 'Jun';


            } else if (byc_delivery_date_alternate[1] == 7) {


                byc_delivery_date_alternate_month = 'Jul';


            } else if (byc_delivery_date_alternate[1] == 8) {


                byc_delivery_date_alternate_month = 'Aug';


            } else if (byc_delivery_date_alternate[1] == 9) {


                byc_delivery_date_alternate_month = 'Sep';


            } else if (byc_delivery_date_alternate[1] == 10) {


                byc_delivery_date_alternate_month = 'Oct';


            } else if (byc_delivery_date_alternate[1] == 11) {


                byc_delivery_date_alternate_month = 'Nov';


            } else if (byc_delivery_date_alternate[1] == 12) {


                byc_delivery_date_alternate_month = 'Dec';


            } else {


                byc_delivery_date_alternate_month = '';


            }


            selected_date = byc_delivery_date_alternate[0] + " " + byc_delivery_date_alternate_month + " " + byc_delivery_date_alternate[2];


            todays_date = new Date();


            todays_date_month = (todays_date.getMonth() + 1);


            todays_date_date = todays_date.getDate();


            todays_date_year = todays_date.getFullYear();


            if (todays_date_month < 10) {


                todays_date_month = '0' + todays_date_month;


            }


            if (todays_date_date < 10) {


                todays_date_date = '0' + todays_date_date;


            }


            if (todays_date_month == 1) {


                todays_date_month = 'Jan';


            } else if (todays_date_month == 2) {


                todays_date_month = 'Feb';


            } else if (todays_date_month == 3) {


                todays_date_month = 'Mar';


            } else if (todays_date_month == 4) {


                todays_date_month = 'Apr';


            } else if (todays_date_month == 5) {


                todays_date_month = 'May';


            } else if (todays_date_month == 6) {


                todays_date_month = 'Jun';


            } else if (todays_date_month == 7) {


                todays_date_month = 'Jul';


            } else if (todays_date_month == 8) {


                todays_date_month = 'Aug';


            } else if (todays_date_month == 9) {


                todays_date_month = 'Sep';


            } else if (todays_date_month == 10) {


                todays_date_month = 'Oct';


            } else if (todays_date_month == 11) {


                todays_date_month = 'Nov';


            } else if (todays_date_month == 12) {


                todays_date_month = 'Dec';


            } else {


                todays_date_month = '';


            }


            todays_formated_date = todays_date_date + " " + todays_date_month + " " + todays_date_year;


            if (Date.parse(selected_date) != Date.parse(todays_formated_date)) {



				<?php if ($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] == 'take_away')
				{ ?>



                start_time_updated_as_per_selected_date = pickup_opening_time;



				<?php
				}

				if ($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] == 'levering')
				{ ?>



                start_time_updated_as_per_selected_date = delivery_opening_time;



				<?php
				} ?>



//alert('Different date, so starting time is store openning time '+delivery_opening_time + pickup_opening_time);


            } else if (Date.parse(selected_date) == Date.parse(todays_formated_date)) {


//if current time is grater than openning time then show current time



				<?php if ($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] == 'take_away')
				{ ?>



//alert(curtime +"||"+ pickup_opening_time);


                if (Date.parse('22 Sep 2017 ' + curtime) <= Date.parse('22 Sep 2017 ' + pickup_opening_time)) {


                    start_time_updated_as_per_selected_date = pickup_opening_time;


                }


                if (Date.parse('22 Sep 2017 ' + curtime) > Date.parse('22 Sep 2017 ' + pickup_opening_time)) {


                    start_time_updated_as_per_selected_date = ByConsoleWooODTStartTimeByInterval(cur_hour, cur_minute); // check this function in wp_footer


                    if (Date.parse('11 Jan 2018 ' + start_time_updated_as_per_selected_date) >= Date.parse('11 Jan 2018 <?php echo get_option('byconsolewooodt_opening_hours_to'); ?>')) {


                        service_status = "closed";


                    }


                }



				<?php
				}

				if ($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] == 'levering')
				{ ?>



                if (Date.parse('22 Sep 2017 ' + curtime) <= Date.parse('22 Sep 2017 ' + delivery_opening_time)) {


                    start_time_updated_as_per_selected_date = delivery_opening_time;


                }


                if (Date.parse('22 Sep 2017 ' + curtime) > Date.parse('22 Sep 2017 ' + delivery_opening_time)) {


                    start_time_updated_as_per_selected_date = ByConsoleWooODTStartTimeByInterval(cur_hour, cur_minute); // check this function in wp_footer


//alert('start_time_updated_as_per_selected_date : '+start_time_updated_as_per_selected_date);


                    if (Date.parse('11 Jan 2018 ' + start_time_updated_as_per_selected_date) >= Date.parse('11 Jan 2018 <?php echo get_option('byconsolewooodt_delivery_hours_to'); ?>')) {


                        service_status = "closed";


                    }


                }



				<?php
				} ?>



//alert('equal date, so starting time is current time '+start_time_updated_as_per_selected_date)


            } else {


                alert('Tienes un error en esta versión del complemento');


            }



			<?php

			if ($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] == 'levering')
			{

			?>



            /*



            echo 'if(curtime > "'.get_option('byconsolewooodt_delivery_hours_from').'"){';



            echo 'var start_time=curtime;';



            echo '}else{';



            echo 'var start_time="'.get_option('byconsolewooodt_delivery_hours_from').'";}';



            //echo 'alert(start_time);';



            */


//alert("service_status : "+service_status);


//alert(start_time_updated_as_per_selected_date);


//alert('<?php echo get_option('byconsolewooodt_delivery_hours_to'); ?>');


            if (service_status == 'closed') {


                jQuery('p.byc_service_time_closed').html('<?php echo __("Estamos cerrados ahora, por favor seleccione otro día.", "byconsole-woo-order-delivery-time"); ?>');


                //alert('time_field_identifier : '+time_field_identifier);


                jQuery(time_field_identifier).css("dispaly:none");


                jQuery(time_field_identifier).addClass("byc_closed_now");


            } else {


                jQuery(time_field_identifier).css("dispaly:block");


                jQuery(time_field_identifier).removeClass("byc_closed_now");


                jQuery('p.byc_service_time_closed').html('');


                jQuery(time_field_identifier).timepicker({


//if it is not today's date selected in dateicker then do not do the past time resriction


//if(jQuery(".byconsolewooodt_widget_date_field").datepicker( "getDate" )!= new Date();


                    "minTime": start_time_updated_as_per_selected_date,


                    "maxTime": "<?php echo get_option('byconsolewooodt_delivery_hours_to'); ?>",


                    "disableTextInput": "true",


                    "disableTouchKeyboard": "true",


                    "scrollDefault": "now",


                    "step": "15",


                    "selectOnBlur": "true",


                    "timeFormat": "<?php echo get_option('byconsolewooodt_hours_format'); ?>"


                });


            }







			<?php

			}

			// lock the time selection based on admin settings for pickup time


			if ($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] == 'take_away')
			{

			?>



//alert("service_status : "+service_status);


            if (service_status == 'closed') {


                jQuery('p.byc_service_time_closed').html('<?php echo __("Estamos cerrados ahora, por favor seleccione otro día.", "byconsole-woo-order-delivery-time"); ?>');


                jQuery(time_field_identifier).css("dispaly:none");


                //alert('time_field_identifier : '+time_field_identifier);


                jQuery(time_field_identifier).css("dispaly:none");


                jQuery(time_field_identifier).addClass("byc_closed_now");


            } else {


                jQuery(time_field_identifier).css("dispaly:block");


                jQuery(time_field_identifier).removeClass("byc_closed_now");


                jQuery('p.byc_service_time_closed').html('');


                jQuery(time_field_identifier).timepicker({


                    "minTime": start_time_updated_as_per_selected_date,


                    "maxTime": "<?php echo get_option('byconsolewooodt_opening_hours_to'); ?>",


                    "disableTextInput": "true",


                    "disableTouchKeyboard": "true",


                    "scrollDefault": "now",


                    "step": "15",


                    "selectOnBlur": "true",


                    "timeFormat": "<?php echo get_option('byconsolewooodt_hours_format'); ?>"


                });


            }



			<?php

			}

			// if no delivery type is not selected then show all times


			if ($byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_type_field'] == '')
			{

			?>



            jQuery(time_field_identifier).timepicker({


                "disableTextInput": "true",


                "disableTouchKeyboard": "true",


                "scrollDefault": "now",


                "step": "15",


                "selectOnBlur": "true",


                "timeFormat": "<?php echo get_option('byconsolewooodt_hours_format'); ?>"


            });



			<?php

			}

			?>



        } // End of function ByconsolewooodtDeliveryWidgetTimePopulate


    </script>


	<?php

	if (is_checkout())
	{ // execute on woocommerce check out page only


		//date and time fields population by plugin settings page



		?>


        <script>


            jQuery(document).ready(function () {



				<?php

				if (get_option('byconsolewooodt_preorder_days') == '')
				{ // if no pre-order date is not set in settings page



				?>



                jQuery("#byconsolewooodt_delivery_date").datepicker({


                    minDate: 0,


                    showAnim: "slideDown",


                    altField: "#byconsolewooodt_delivery_date_alternate",


                    altFormat: "dd/m/yy",


                    onSelect: function () {
                        jQuery("#byconsolewooodt_delivery_time").timepicker("remove");
                        jQuery("#byconsolewooodt_delivery_time").val('');
                        ByconsolewooodtDeliveryWidgetTimePopulate("#byconsolewooodt_delivery_date", "#byconsolewooodt_delivery_time");
                    } // reset timepicker on date selection to get new time value depending date selected here AND THEN call call time population function


                });



				<?php

				}
				else
				{ //if no pre-order date is set in settings page do the date selection restriction



				?>



                jQuery("#byconsolewooodt_delivery_date").datepicker({


                    minDate: 0,


                    maxDate: "<?php echo get_option('byconsolewooodt_preorder_days'); ?>D",


                    showOtherMonths: true,


                    selectOtherMonths: true,


                    showAnim: "slideDown",


                    altField: "#byconsolewooodt_delivery_date_alternate",


                    altFormat: "dd/m/yy",


                    onSelect: function () {
                        jQuery("#byconsolewooodt_delivery_time").timepicker("remove");
                        jQuery("#byconsolewooodt_delivery_time").val('');
                        ByconsolewooodtDeliveryWidgetTimePopulate("#byconsolewooodt_delivery_date", "#byconsolewooodt_delivery_time");
                    } // reset timepicker on date selection to get new time value depending date selected here AND THEN call call time population function


                });



				<?php
				} ?>



            })


            jQuery(document).ready(function () {


//jQuery("#byconsolewooodt_delivery_date_alternate").css("display","none");


                jQuery(".byconsolewooodt_widget_date_field").val("");


                jQuery(".byconsolewooodt_widget_time_field").val("");


            });


        </script>


		<?php

		// refresh the page once delivery type is changed and if the checkout page dont have the widget present (if it has widget present it will be refresh by widget itself)


		//check if it is checkout page


		//check if widget is present on checkout page


		//if widget is not present create it and make it hide


		echo '<div style="display:none;">';

		the_widget('byconsolewooodt_widget');

		echo '</div>';

		?>


        <script>


            //alertboxes to translate


            jQuery(document).ready(function () {


                jQuery('#byconsolewooodt_delivery_time').on('click', function () {


                    if (!jQuery('#byconsolewooodt_delivery_time').hasClass('ui-timepicker-input')) {


                        //alert("checkout");


                        alert("<?php echo __("Por favor, seleccione la fecha de nuevo", "byconsole-woo-order-delivery-time"); ?>");


                    }


                });


                jQuery('#byconsolewooodt_delivery_time').attr("readonly");

                jQuery("#byconsolewooodt_delivery_date").prop("readonly", true);


            })


        </script>


		<?php

	} // is_checkout


	else
	{

		?>


        <script>


            //alertboxes to translate


            jQuery(document).ready(function () {


                jQuery('.byconsolewooodt_widget_time_field').on('click', function () {


                    if (!jQuery('.byconsolewooodt_widget_time_field').hasClass('ui-timepicker-input')) {


                        //alert("widget");


                        alert("<?php echo __("Por favor, seleccione la fecha de nuevo", "byconsole-woo-order-delivery-time"); ?>");


                    }


                });


            });


        </script>


		<?php

	} // !is_checkout



} //byconsolewooodt_footer_script


add_action('wp_footer', 'byconsolewooodt_footer_script');

//add_action('wp_footer','woocommerce_package_rates',999);


add_action('wp_footer', 'recalculate_shipping');

function recalculate_shipping()
{

	foreach (WC()
				 ->cart
				 ->get_cart() as $key => $value)
	{

		WC()
			->cart
			->set_quantity($key, $value['quantity'] + 1);

		WC()
			->cart
			->set_quantity($key, $value['quantity']);

		break;

	}

}

/*============SEGUNDO PLUGIN ADD-ONS============*/

/**
 * Required functions.
 */
if (!function_exists('woothemes_queue_update'))
{
	require_once ('woo-includes/woo-functions.php');
}

/**
 * Plugin updates.
 */
//woothemes_queue_update( plugin_basename( __FILE__ ), '147d0077e591e16db9d0d67daeb8c484', '18618' );

/**
 * WooCommerce fallback notice.
 *
 * @since 4.1.2
 * @return string
 */
function woocommerce_product_addons_missing_wc_notice()
{
	/* translators: %s WC download URL link. */

}

register_activation_hook(__FILE__, 'woocommerce_product_addons_activation');

/**
 * Activation.
 *
 * @since 3.0.0
 */
function woocommerce_product_addons_activation()
{
	set_transient('wc_pao_activation_notice', true, 60);
	set_transient('wc_pao_pre_wc_30_notice', true, 60);

	// Opciones principales por defecto
    $opciones = json_decode( '{"byconsolewooodt_preorder_days":"0","byconsolewooodt_opening_hours_from":"08:00","byconsolewooodt_opening_hours_to":"23:59","byconsolewooodt_delivery_hours_from":"08:30","byconsolewooodt_delivery_hours_to":"23:59","byconsolewooodt_delivery_times":"Tiempo m\u00ednimo de preparaci\u00f3n y entrega 30 minutos","byconsolewooodt_takeaway_lable":"Recoger","byconsolewooodt_delivery_lable":"Domicilio","byconsolewooodt_date_field_text":"Selecciona el d\u00eda de la entrega","byconsolewooodt_time_field_text":"Tiempo m\u00ednimo de entrega y preparaci\u00f3n 30min.","byconsolewooodt_orders_delivered":"El pedido ser\u00e1 entregado en... [byc_delivery_date] a [byc_delivery_time]","byconsolewooodt_orders_pick_up":"El pedido puede ser recogido en [byc_pickup_date] a [byc_pickup_time] en nuestro establecimiento de la Cale de arriba","byconsolewooodt_widget_field_position":"top","byconsolewooodt_widget_tipo_entrega":[],"byconsolewooodt_chekout_page_section_heading":"Recuerde que el tiempo m\u00ednimo de entrega y preparaci\u00f3n es de 30min.","byconsolewooodt_chekout_page_order_type_label":"Seleccione si su pedido es para Recoger en Local o prefiere su env\u00edo a domicilio.","byconsolewooodt_chekout_page_date_label":"Seleccionar fecha","byconsolewooodt_chekout_page_time_label":"Seleccionar hora","byconsolewooodt_hours_format":"H:i:s","byconsolewooodt_chekout_articulos_extra_type_label":"","byconsolewooodt_chekout_comentarios_libres_type_label":"","byconsolewooodt_chekout_no_disponible_pedido_type_label":"La tienda seleccionada no dispone de reparto en la direcci\u00f3n introducida, rev\u00edsela o si lo desea puede realizar un pedido a recoger.","byconsolewooodt_chekout_no_disponible_pedido_finalizar_type_label":"La tienda seleccionada no dispone de reparto en la direcci\u00f3n introducida, rev\u00edsela o si lo desea puede realizar un pedido a recoger.","byconsolewooodt_detalels_del_envio_label":"Detalles del env\u00edo","byconsolewooodt_hay_notas_label":"","byconsolewooodt_permitir_envio_diferente_label":""}', ARRAY_A );

	foreach ( $opciones as $key => $opcione ) {
        update_option( $key, $opcione );
    }

}

add_action('plugins_loaded', 'woocommerce_product_addons_init', 9);

function woocommerce_product_addons_init()
{
	load_plugin_textdomain('woocommerce-product-addons', false, plugin_basename(dirname(__FILE__)) . '/languages');

	if (!class_exists('WooCommerce'))
	{
		add_action('admin_notices', 'woocommerce_product_addons_missing_wc_notice');
		return;
	}

	if (!class_exists('WC_Product_Addons')):
		define('WC_PRODUCT_ADDONS_VERSION', '3.0.10');
		define('WC_PRODUCT_ADDONS_MAIN_FILE', __FILE__);
		define('WC_PRODUCT_ADDONS_PLUGIN_URL', untrailingslashit(plugins_url(basename(plugin_dir_path(__FILE__)) , basename(__FILE__))));
		define('WC_PRODUCT_ADDONS_PLUGIN_PATH', untrailingslashit(plugin_dir_path(__FILE__)));

		/**
		 * Main class.
		 */
		class WC_Product_Addons
		{

			protected $groups_controller;

			/**
			 * Constructor.
			 */
			public function __construct()
			{
				$this->init();
				add_action('init', array(
					$this,
					'init_post_types'
				) , 20);
				add_action('init', array(
					'WC_Product_Addons_install',
					'init'
				));
				add_action('rest_api_init', array(
					$this,
					'rest_api_init'
				));
				add_filter('plugin_action_links_' . plugin_basename(__FILE__) , array(
					$this,
					'action_links'
				));
				add_action('admin_notices', array(
					$this,
					'notices'
				));
			}

			/**
			 * Initializes plugin classes.
			 *
			 * @version 2.9.0
			 */
			public function init()
			{
				if (defined('WC_VERSION') && version_compare(WC_VERSION, '3.0.0', '<'))
				{
					require_once (dirname(__FILE__) . '/legacy/class-wc-product-addons-helper.php');
				}
				else
				{
					require_once (dirname(__FILE__) . '/includes/class-wc-product-addons-helper.php');
				}

				// Pre 3.0 conversion helper to be remove in future.
				require_once (dirname(__FILE__) . '/includes/updates/class-wc-product-addons-3-0-conversion-helper.php');

				require_once (dirname(__FILE__) . '/includes/class-wc-product-addons-install.php');

				if (defined('WC_VERSION') && version_compare(WC_VERSION, '3.0.0', '<'))
				{
					// Core (models)
					require_once (dirname(__FILE__) . '/legacy/groups/class-product-addon-group-validator.php');
					require_once (dirname(__FILE__) . '/legacy/groups/class-product-addon-global-group.php');
					require_once (dirname(__FILE__) . '/legacy/groups/class-product-addon-product-group.php');
					require_once (dirname(__FILE__) . '/legacy/groups/class-product-addon-groups.php');
				}
				else
				{
					// Core (models)
					require_once (dirname(__FILE__) . '/includes/groups/class-wc-product-addons-group-validator.php');
					require_once (dirname(__FILE__) . '/includes/groups/class-wc-product-addons-global-group.php');
					require_once (dirname(__FILE__) . '/includes/groups/class-wc-product-addons-product-group.php');
					require_once (dirname(__FILE__) . '/includes/groups/class-wc-product-addons-groups.php');
				}

				// Admin
				if (is_admin())
				{
					require_once (dirname(__FILE__) . '/includes/admin/class-wc-product-addons-privacy.php');

					// Handle WooCommerce 3.0 compatibility.
					if (defined('WC_VERSION') && version_compare(WC_VERSION, '3.0.0', '<'))
					{
						require_once (dirname(__FILE__) . '/legacy/admin/class-product-addon-admin.php');
						require_once (dirname(__FILE__) . '/legacy/admin/class-product-addon-admin-legacy.php');

						$GLOBALS['Product_Addon_Admin'] = new Product_Addon_Admin_Legacy();
					}
					else
					{
						require_once (dirname(__FILE__) . '/includes/admin/class-wc-product-addons-admin.php');

						$GLOBALS['Product_Addon_Admin'] = new WC_Product_Addons_Admin();
					}
				}

				// Handle WooCommerce 3.0 compatibility.
				if (defined('WC_VERSION') && version_compare(WC_VERSION, '3.0.0', '<'))
				{
					require_once (dirname(__FILE__) . '/legacy/includes/class-product-addon-display.php');
					require_once (dirname(__FILE__) . '/legacy/includes/class-product-addon-cart.php');
					require_once (dirname(__FILE__) . '/legacy/includes/class-product-addon-ajax.php');

					require_once (dirname(__FILE__) . '/legacy/includes/class-product-addon-display-legacy.php');
					require_once (dirname(__FILE__) . '/legacy/includes/class-product-addon-cart-legacy.php');
					require_once (dirname(__FILE__) . '/legacy/includes/class-wc-addons-ajax.php');

					$GLOBALS['Product_Addon_Display'] = new Product_Addon_Display_Legacy();
					$GLOBALS['Product_Addon_Cart'] = new Product_Addon_Cart_Legacy();
					new WC_Addons_Ajax();
				}
				else
				{
					require_once (dirname(__FILE__) . '/includes/class-wc-product-addons-display.php');
					require_once (dirname(__FILE__) . '/includes/class-wc-product-addons-cart.php');
					require_once (dirname(__FILE__) . '/includes/class-wc-product-addons-ajax.php');

					$GLOBALS['Product_Addon_Display'] = new WC_Product_Addons_Display();
					$GLOBALS['Product_Addon_Cart'] = new WC_Product_Addons_Cart();
					new WC_Product_Addons_Cart_Ajax();
				}
			}

			/**
			 * Init post types used for addons.
			 */
			public function init_post_types()
			{
				register_post_type('global_product_addon', array(
					'public' => false,
					'show_ui' => false,
					'capability_type' => 'product',
					'map_meta_cap' => true,
					'publicly_queryable' => false,
					'exclude_from_search' => true,
					'hierarchical' => false,
					'rewrite' => false,
					'query_var' => false,
					'supports' => array(
						'title'
					) ,
					'show_in_nav_menus' => false,
				));

				register_taxonomy_for_object_type('product_cat', 'global_product_addon');
			}

			/**
			 * Initialize the REST API
			 *
			 * @since 2.9.0
			 * @param WP_Rest_Server $wp_rest_server
			 */
			public function rest_api_init($wp_rest_server)
			{
				require_once (dirname(__FILE__) . '/includes/api/wc-product-add-ons-groups-controller-v1.php');
				$this->groups_controller = new WC_Product_Add_Ons_Groups_Controller();
				$this
					->groups_controller
					->register_routes();
			}

			/**
			 * Plugin action links
			 */
			public function action_links($links)
			{
				$plugin_links = array(
				);
				return array_merge($plugin_links, $links);
			}

			/**
			 * On activation.
			 * Runs on activation. Assigns a notice message to a WordPress option.
			 */
			public function notices()
			{
				$show_activate_notice = get_transient('wc_pao_activation_notice');

				if ($show_activate_notice)
				{
					echo '<div class="notice is-dismissible updated"><p><strong>' . __('¡Los complementos de productos de WooCommerce están listos para funcionar!', 'woocommerce-product-addons') . '</strong></p><p>' . __('Cree un complemento que se aplique a cada producto o aplíquelo a categorías específicas. Cree un complemento para un producto individual editando el producto.', 'woocommerce-product-addons') . '</p><p><a href="' . esc_url(admin_url()) . 'edit.php?post_type=product&page=addons" class="button button-primary">' . __('Crear complemento', 'woocommerce-product-addons') . '</a>&nbsp;&nbsp;<a href="' . esc_url(admin_url()) . 'edit.php?post_type=product" class="button">' . __('Find products', 'woocommerce-product-addons') . '</a></p></div>';

					delete_transient('wc_pao_activation_notice');
				}
			}
		}

		new WC_Product_Addons();

	endif;
}

function wooglop_addons_tiene_extras_menus_comentarios( $product = null ) {
	if ( is_null( $product ) ) {
	    /** @var WC_Product $product */
		$product = $GLOBALS['product'];
	}

	// Get addons.
	$product_addons = WC_Product_Addons_Helper::get_product_addons( $product->get_id(), false );
	if ( empty( $product_addons ) ) {
	    return false;
    }

	$resp = false;

	foreach ( $product_addons as $addon ) {
        if (
            ( 'Comentarios Libre' === $addon['name'] ) ||
            ( 'Artículos Extras' === $addon['name'] ) ||
            ( 's' === (string) $addon['is_menu'] )
        ) {
            $resp = true;
        }
	}

	return $resp;
}
if ( is_wooglop_addons_only_cantidad_unitaria() ) {
	add_filter( 'woocommerce_quantity_input_args', 'wooglop_addons_quantity', 1, 2 );
}
function wooglop_addons_quantity( $args, $product ) {
	$resp = wooglop_addons_tiene_extras_menus_comentarios( $product );
	if ( $resp ) {
		$args['max_value'] = 1;
		$args['min_value'] = 1;
	}

	return $args;
}

add_action( 'woocommerce_before_thankyou', 'addons_su_turno' );
add_action( 'woocommerce_email_order_details', 'addons_su_turno_mail', 1, 4 );

function addons_su_turno_mail( $order, $sent_to_admin, $plain_text, $email ) {
	if ( get_class($email) == 'WC_Email_Customer_Invoice' ) {
		addons_su_turno( $order->get_id() );
	}
}

function is_entrega_domicilio($order): bool {
	return 'levering' == get_post_meta($order, 'byconsolewooodt_delivery_type', true);
}

function addons_su_turno( $order ) {
	if ('on' == get_byconsolewooodt_chekout_enable_su_turno() && ! is_entrega_domicilio($order)) {
		$orderO = new WC_Order($order);
		?><div style="color: #c00000">
		<h2  style="color: #c00000"><?php echo get_byconsolewooodt_chekout_texto_su_turno() ?>
			P<?php echo str_pad( substr($order, strlen($order) - 2), '2', '0', STR_PAD_LEFT ); ?>
		</h2></div><?php
	}
}




/**
 * 30/06/2023
 * Adaptación wooglop para pasarela pago MONEI
 */
add_filter( 'wc_gateway_monei_create_payload', 'check_payload_monei', 10, 1);

function check_payload_monei( $payload ) {
    if  ( ! isset( $payload['orderId'] ) ) {
        return $payload;
    }
    $order_id = $payload['orderId'];
	$tipo = get_post_meta( $order_id, 'byconsolewooodt_delivery_type', true );


    if ( ! isset( $payload['customer'] ) ) {
	    $payload['customer'] = array();
    }

    if (
        empty( $payload['customer']['email'] )
    ) {
	    $payload['customer']['email'] = 'hola@glop.es';
    }
    if (
        empty( $payload['customer']['name'] )
    ) {
	    $payload['customer']['name'] = 'Glop Pos SLU';
    }
    if (
        empty( $payload['customer']['phone'] )
    ) {
//	    $payload['customer']['phone'] = '965561728';
        // 27/09/2023 Parece que MONEI no acepta el formato +34 como teléfono.
//	    $payload['customer']['phone'] = '+34';
//	    $payload['customer']['phone'] = '';
        // 28/09/2023 MONEI nos indica que no lo enviemos.
        unset( $payload['customer']['phone'] );
    }
	if ( ! isset( $payload['billingDetails'] ) ) {
		$payload['billingDetails'] = array();
	}
	if ( ! isset( $payload['billingDetails']['address'] ) ) {
		$payload['billingDetails']['address'] = array();
	}

	if (
        empty( $payload['billingDetails']['address']['country'] )
    ) {
		$payload['billingDetails']['address']['country'] = 'España';
    }

	if (
        empty( $payload['billingDetails']['email'] )
    ) {
		$payload['billingDetails']['email'] = 'hola@glop.es';
    }

	if (
        empty( $payload['shippingDetails']['email'] )
    ) {
		$payload['shippingDetails']['email'] = 'hola@glop.es';
    }
    if (
        empty( $payload['shippingDetails']['address']['country'] )
    ) {
	    $payload['shippingDetails']['address']['country'] = 'España';
    }
	if ( '62.57.20.247' === getenv( 'REMOTE_ADDR' ) ) {
//		echo "<textarea style='height:1000px;width:500px;'>";print_r($payload);echo "</textarea>";exit();
	}
    return $payload;
}
